=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2006-06-07 15:10:21 +0000
+++ bzrlib/builtins.py	2006-06-07 15:18:15 +0000
@@ -840,6 +840,7 @@
     takes_args = ['file*']
     takes_options = ['verbose', Option('new', help='remove newly-added files')]
     aliases = ['rm']
+    encoding_type = 'replace'
     
     def run(self, file_list, verbose=False, new=False):
         tree, file_list = tree_files(file_list)
@@ -854,7 +855,7 @@
             file_list = sorted([f[0] for f in added[0]], reverse=True)
             if len(file_list) == 0:
                 raise BzrCommandError('No matching files.')
-        tree.remove(file_list, verbose=verbose)
+        tree.remove(file_list, verbose=verbose, to_file=self.outf)
 
 
 class cmd_file_id(Command):

=== modified file 'bzrlib/tests/blackbox/test_non_ascii.py'
--- bzrlib/tests/blackbox/test_non_ascii.py	2006-06-07 15:10:21 +0000
+++ bzrlib/tests/blackbox/test_non_ascii.py	2006-06-07 15:18:15 +0000
@@ -276,7 +276,6 @@
     def test_remove_verbose(self):
         bzr = self.run_bzr_decode
 
-        raise TestSkipped('bzr remove --verbose uses tree.remove, which calls print directly.')
         fname = self.info['filename']
         txt = bzr('remove', '--verbose', fname, encoding='ascii')
 

=== modified file 'bzrlib/textui.py'
--- bzrlib/textui.py	2006-06-07 15:10:21 +0000
+++ bzrlib/textui.py	2006-06-07 15:18:15 +0000
@@ -16,8 +16,10 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-
-def show_status(state, kind, name):
+import sys
+
+
+def show_status(state, kind, name, to_file=None):
     if kind == 'directory':
         # use this even on windows?
         kind_ch = '/'
@@ -29,5 +31,8 @@
 
     assert len(state) == 1
         
-    print state + '       ' + name + kind_ch
+    if to_file is None:
+        to_file = sys.stdout
+
+    to_file.write(state + '       ' + name + kind_ch + '\n')
     

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2006-06-07 11:13:02 +0000
+++ bzrlib/workingtree.py	2006-06-07 15:18:15 +0000
@@ -1240,7 +1240,7 @@
         return result
 
     @needs_write_lock
-    def remove(self, files, verbose=False):
+    def remove(self, files, verbose=False, to_file=None):
         """Remove nominated files from the working inventory..
 
         This does not remove their text.  This does not run on XXX on what? RBC
@@ -1275,7 +1275,7 @@
                     new_status = 'I'
                 else:
                     new_status = '?'
-                show_status(new_status, inv[fid].kind, quotefn(f))
+                show_status(new_status, inv[fid].kind, quotefn(f), to_file=to_file)
             del inv[fid]
 
         self._write_inventory(inv)

